import 'isomorphic-fetch';
import { Authorizer } from './interfaces';
import { ClientOptions } from './clientOptions';
export interface EndpointConfig {
    base: string;
    version?: string;
    action?: string;
    params?: any;
    qs?: any;
}
declare type Endpoint = EndpointConfig | string;
export interface ClientConfig {
    authorize(request: Function): Promise<any>;
}
interface RequestConfig {
    formatter?(response: Response): Promise<any>;
    companyId?: string | number;
    headers?: {
        [key: string]: string;
    };
}
export declare class Client {
    private readonly options;
    private authorize;
    private request;
    constructor(authorizer: Authorizer, config: RequestInit, options: ClientOptions);
    get: (endpoint: Endpoint, reqConfig?: RequestConfig) => Promise<any>;
    post: (endpoint: Endpoint, payload: any, reqConfig?: RequestConfig) => Promise<any>;
    patch: (endpoint: Endpoint, payload: any, reqConfig?: RequestConfig) => Promise<any>;
    put: (endpoint: Endpoint, payload: any, reqConfig?: RequestConfig) => Promise<any>;
    delete: (endpoint: Endpoint, payload?: any, reqConfig?: RequestConfig) => Promise<any>;
    private url;
    private urlConfig;
    private version;
}
declare function client(authorizer: Authorizer, defaults: RequestInit, options: ClientOptions | string): Client;
export default client;
